
%==============================================
%This code is written based on the Deep Learning Matlab toolbox

%==============================================
clc;
clear all;
addpath(genpath(pwd));

% load the ground truth and the hyperspectral image
%data
path='.\images\';
inputsimage = 'PaviaU.mat';
Datapath = [path,inputsimage];
load (Datapath);

%groundtruth
inputGroundtruth = 'PaviaU_gt.mat';
GTpath = [path,inputGroundtruth];
load (GTpath);

Percent_train = 0.1;
Percent_test = 1;

windowsize = 9;
pcasize = 10;
[paviaU_Train,paviaU_Test] = ThreeD_train_and_test_sample_patial_Spectral(paviaU,paviaU_gt,Percent_train,Percent_test,windowsize,pcasize);

traindata = paviaU_Train.trainData;
trainlabel = paviaU_Train.trainLabel;

testdata = paviaU_Test.testData;
testlabel = paviaU_Test.testLabel;

rng(0)
cnn.layers = {
    struct('type', 'i') %input layer
    struct('type', 'c', 'outputmaps', 6, 'kernelsize1', 4,'kernelsize2', 4,'kernelsize3', 5) %convolution layer
    struct('type', 's', 'scale', 2) %sub sampling layer
    struct('type', 'c', 'outputmaps', 12, 'kernelsize1', 3, 'kernelsize2', 3,'kernelsize3', 3) %convolution layer
};

%full connection
cnn.numfullLine = 100;

%Iterative number
cnn.numepochs = 2; 

outlabel = Three_dimension_Classification(traindata,trainlabel,testdata,testlabel,cnn);

%===========quality metrics and visual======================
Originalgroundtruth = 'PaviaU_gt.mat';
Groundtruthpath = [path,Originalgroundtruth];
load (Groundtruthpath);

[OA,AA,Kappa] = Compute_evaluate(trainlabel,testlabel,outlabel,paviaU_gt,paviaU_Test);
OA
AA
Kappa








